#define	A	26
#define	B	52
#define	LAMBDA	808

process count = 4; /* 1 is for the auctioneer, the others for bidders. */ 
          
global synchronizer bid; 
global discrete highest, second:0..#PS; 
global discrete query_count:0..2;  
global discrete auction_status: 0..1; 

mode auctioneer_idle (true) { 
/*1*/	when (true) 
	  may auction_status = 1; highest = 0; second = 0; query_count = 0; 
	    goto auctioneer_active; /* 1 */
}

mode auctioneer_active (true) { 
/*2*/	when ?bid@Q (true) may second = highest; highest = Q; query_count=0; /* 2 */
/*3*/	when (query_count<2) may query_count++1;  
/*4*/ 	when (query_count==2) 
	  may auction_status = 0; query_count=0; goto auctioneer_idle; 
}

mode bidder_idle (true) { 
/*5*/	when (auction_status == 1) may goto bidder_active; /* 5 */
}


mode bidder_active (true) {
/*6*/	when !bid (true) may ; /* 6 */
/*8*/	when (auction_status == 0) may goto bidder_idle; 
}  



initially 
    auction_status == 0
&&  highest == 0 && second == 0
&&  query_count == 0 
&&  auctioneer_idle@(1)  
&&  forall i:2..#PS, bidder_idle@(i); 

